<template>
  <v-container
    text-center
    fluid
    class="pa-0"
  > 
    <v-row v-if="displayVerifiedMessage">
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          multi-line
          color="info"
          vertical
        >
          <div>
            {{ $t('snackbar1') }}
            <a :href="$t('profileLink')">
              " {{ $t('myProfile') }} "
            </a>
            {{ $t('snackbar2') }}
          </div>
          <v-btn
            color="info"
            elevation="0"
            @click="snackbar = false"
          >
            <v-icon
              color="primary"
            >
              mdi-close
            </v-icon>
          </v-btn>
        </v-snackbar>
      </v-col>
    </v-row>

    <v-row
      v-if="displayDeleteAccount"
      class="mt-n4"
    >
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          color="info"
        >
          {{ $t('snackbar-account-delete') }}
          <template v-slot:action="{ attrs }">
            <v-btn
              color="primary"
              text
              v-bind="attrs"
              @click="snackbar = false"
            >
              <v-icon
                color="primary"
              >
                mdi-close
              </v-icon>
            </v-btn>
          </template>
        </v-snackbar>
      </v-col>
    </v-row>
    <v-row
      v-if="displayUnsubscribeEmail"
      class="mt-n4"
    >
      <v-col>
        <v-snackbar
          v-model="snackbar"
          top
          multi-line
          color="info"
          vertical
        >
          <div>
            {{ displayUnsubscribeEmail }}
          </div>
          <v-btn
            color="info"
            elevation="0"
            @click="snackbar = false"
          >
            <v-icon
              color="primary"
            >
              mdi-close
            </v-icon>
          </v-btn>
        </v-snackbar>
      </v-col>
    </v-row>
    <div
      :style="'background-image:url(\''+$t('urlBackground')+'\');background-size:cover;height:920px'"
      class="mb-12"
    >
      <v-row
        align="center"
        justify="center"
        class="py-12"
      >
        <v-col
          cols="12"
          lg="5"
          class="text-center"
        >
          <h1
            class="font-weight-bold title1"
            v-html="$t('title1')"
          />
        </v-col>
      </v-row>
      <v-row
        align="center"
        justify="center"
        class="py-12 mt-n16"
      >
        <v-col
          cols="12"
          lg="5"
          class="text-center white searchComponent mt-16 pa-0"
        >
          <div class="pa-5 mt-n10">
            <search
              :geo-search-url="geoSearchUrl"
              :geo-complete-results-order="geoCompleteResultsOrder"
              :geo-complete-palette="geoCompletePalette"
              :geo-complete-chip="geoCompleteChip"
              color-button="text-none primary--text"
              search-button-class="text-none secondary"
              :user="user"
              :regular="regular"
              :punctual-date-optional="punctualDateOptional"
              class-align-publish-button="text-center"
              class-align-search-button="text-center"
              full-size
              :image-swap="$t('urlImageSwap')"
            />
          </div>
        </v-col>
      </v-row>
    </div>

    <v-row
      align="center"
      justify="center"
    >
      <v-col
        cols="12"
      >
        <home-content
          :community-display="communityDisplay"
          :event-display="eventDisplay"
          :solidary-display="solidaryDisplay"
        />
      </v-col>
    </v-row>
    <m-dialog
      v-if="isEecAvailable" 
      :eec-instance="eecInstance"
    />
  </v-container>
</template>

<script>
import {merge} from "lodash";
import {messages_en, messages_fr, messages_eu} from "@translations/components/home/Home/";
import {messages_client_en, messages_client_fr, messages_client_eu} from "@clientTranslations/components/home/Home/";
import Search from "@components/carpool/search/Search";
import HomeContent from "@clientComponents/home/HomeContent";
import MDialog from "@components/utilities/MDialog";

let MessagesMergedEn = merge(messages_en, messages_client_en);
let MessagesMergedEu = merge(messages_eu, messages_client_eu);
let MessagesMergedFr = merge(messages_fr, messages_client_fr);

export default {
  i18n: {
    messages: {
      'en': MessagesMergedEn,
      'eu': MessagesMergedEu,
      'fr': MessagesMergedFr
    }
  },
  components: {
    Search,
    HomeContent,
    MDialog
  },
  props: {
    geoSearchUrl: {
      type: String,
      default: ""
    },
    user: {
      type: Object,
      default: null
    },
    regular: {
      type: Boolean,
      default: false
    },
    punctualDateOptional: {
      type: Boolean,
      default: false
    },
    debug: {
      type: Boolean,
      default: false
    },
    position: {
      type: String,
      default: ""
    },
    transitionName: {
      type: String,
      default: ""
    },
    solidaryDisplay: {
      type: Boolean,
      default: false
    },
    eventDisplay: {
      type: Boolean,
      default: false
    },
    displayDeleteAccount: {
      type: Number,
      default: 0
    },
    displayUnsubscribeEmail: {
      type: String,
      default: ""
    },
    communityDisplay: {
      type: Boolean,
      default: false
    },
    publishButtonAlwaysActive:{
      type: Boolean,
      default:false
    },
    // params to add to the publish and search routes
    params: {
      type: Object,
      default: null
    },
    urlMobile: {
      type: String,
      default: null
    },
    informativeMessageActive: {
      type: Boolean,
      default: false
    },
    informativeMessageText: {
      type: String,
      default: null
    },
    searchComponentHorizontal: {
      type: Boolean,
      default: false
    },
    geoCompleteResultsOrder: {
      type: Array,
      default: null
    },
    geoCompletePalette: {
      type: Object,
      default: () => ({})
    },
    geoCompleteChip: {
      type: Boolean,
      default: false
    },
    territoryId: {
      type: Number,
      default: null
    },
    mobConnectSubscriptions: {
      type: String,
      default: null
    },
    eecInstance: {
      type: Object,
      default: () => ({})
    }
  },
  data () {
    return {
      snackbar: true,
      displayVerifiedMessage: false,
    }
  },
  computed: {
    isEecAvailable() {
      return this.eecInstance && this.eecInstance.available;
    }
  },
  mounted() {
    if (this.user !==null && this.user.validatedDate !== null){
      this.checkVerifiedPhone();
    } else {
      this.checkVerifiedEmail();
    }

    // Displays the mobConnect snackbar
    if ((this.mobConnectSubscriptions && 'null' !== this.mobConnectSubscriptions) || '' === this.mobConnectSubscriptions) {
      const baseText = this.$t('mobConnect-snackbar.text.base');
      const additionnalText = '1' === this.mobConnectSubscriptions ? this.$t('mobConnect-snackbar.text.success') : this.$t('mobConnect-snackbar.text.error');

      this.mobConnect_snackbar_text = `${baseText} ${additionnalText}`;
      this.mobConnectSnackbar = true;
    }
  },
  methods:{
    checkVerifiedPhone() {
      if (this.user !==null && this.user.telephone !== null) {
        this.displayVerifiedMessagePhone = this.user.phoneValidatedDate ? false : true;
      }
    },
    checkVerifiedEmail() {
      if (this.user !==null && this.user.email !== null) {
        this.displayVerifiedMessageEmail = this.user.validatedDate ? false : true;
      }
    }
  }
};
</script>
<style lang="scss" scoped>
  .searchComponent{
      background-color: rgba(255,255,255, 0.8)!important;
      border-radius: 25px;
  }
  .title1{
    font-size: 3rem
  }
</style>